' Simple text to CHR$ converter. Can be useful if we want to hide text strings
' in a program. Text like "Enter reg. code" is visible in compiled program code,
' but CHR$(69, 110, 116, 101, 114, 32, 114, 101, 103, 46, 32, 99, 111, 100, 101)
' is not and gives same output..  :)
'
' Can also be used to check ASC value(s) of any given character(s).
'
' Public Domain by Borje Hagsten, October 2001.
'------------------------------------------------------------------------------
#COMPILE EXE
#INCLUDE "WIN32API.INC"

%IDBTN_TXTCHR = 120
%IDBTN_CHRTXT = 121
%IDBTN_INFO   = 122
%ID_TEXT1     = 130
%ID_TEXT2     = 131

DECLARE CALLBACK FUNCTION DlgProc

'
' MAIN ENTRANCE
'
FUNCTION PBMAIN
  LOCAL hDlg AS LONG

  DIALOG NEW 0, "CHR$ converter", , , 255, 94, %WS_CAPTION OR %WS_MINIMIZEBOX OR %WS_SYSMENU TO hDlg

  'For icon from resource, instead use something like, LoadIcon(hInst, "APPICON")
  DIALOG SEND hDlg, %WM_SETICON, %ICON_SMALL, LoadIcon(%NULL, BYVAL %IDI_APPLICATION)
  DIALOG SEND hDlg, %WM_SETICON, %ICON_BIG, LoadIcon(%NULL, BYVAL %IDI_APPLICATION)

  CONTROL ADD TEXTBOX, hDlg, %ID_TEXT1, "", 4,  4, 180, 40, %WS_CHILD OR %ES_MULTILINE OR _
                             %WS_VSCROLL OR %ES_AUTOVSCROLL OR %ES_NOHIDESEL OR _
                             %ES_WANTRETURN, %WS_EX_CLIENTEDGE
  CONTROL ADD BUTTON, hDlg&, %IDBTN_TXTCHR, "&Text to CHR$", 190,  5, 60, 14

  CONTROL ADD TEXTBOX, hDlg, %ID_TEXT2, "", 4, 50, 180, 40, %WS_CHILD OR %ES_MULTILINE OR _
                             %WS_VSCROLL OR %ES_AUTOVSCROLL OR %ES_NOHIDESEL OR _
                             %ES_WANTRETURN, %WS_EX_CLIENTEDGE
  CONTROL ADD BUTTON, hDlg&, %IDBTN_CHRTXT, "&CHR$ to Text", 190, 50, 60, 14
  CONTROL ADD BUTTON, hDlg&, %IDBTN_INFO,   "&Info",         190, 76, 30, 14
  CONTROL ADD BUTTON, hDlg&, %IDCANCEL,     "E&xit",         220, 76, 30, 14

  DIALOG SHOW MODAL hDlg CALL DlgProc

END FUNCTION

'
' DIALOG MESSAGES
'
CALLBACK FUNCTION DlgProc
  SELECT CASE CBMSG
     CASE %WM_INITDIALOG
        LOCAL I AS LONG, txt AS STRING, txt2 AS STRING
        CONTROL SET FOCUS CBHNDL, %ID_TEXT1

     CASE %WM_COMMAND
        IF CBCTLMSG <> %BN_CLICKED THEN EXIT FUNCTION
        SELECT CASE CBCTL
           CASE %IDBTN_TXTCHR 'text to CHR$
              IF CBCTLMSG = %BN_CLICKED THEN 
                 txt2 = ""
                 CONTROL GET TEXT CBHNDL, %ID_TEXT1 TO txt
                 IF LEN(txt) THEN
                    txt2 = "CHR$("
                    FOR I = 1 TO LEN(txt)
                       txt2 = txt2 & FORMAT$(ASC(txt, I)) & ", "
                    NEXT I
                    txt2 = LEFT$(txt2, LEN(txt2) - 2) & ")" 'cut last comma and add )
                 END IF
                 CONTROL SET TEXT CBHNDL, %ID_TEXT2, txt2
              END IF

           CASE %IDBTN_CHRTXT 'CHR$ to text
              IF CBCTLMSG = %BN_CLICKED THEN 
                 txt2 = ""
                 CONTROL GET TEXT CBHNDL, %ID_TEXT2 TO txt
                 txt = REMOVE$(txt, ANY "CHR$()")
                 IF LEN(txt) THEN
                    FOR I = 1 TO PARSECOUNT(txt, ", ")
                       txt2 = txt2 & CHR$(MAX&(9, MIN&(255, VAL(PARSE$(txt, ", ", I)))))
                    NEXT I
                 END IF
                 CONTROL SET TEXT CBHNDL, %ID_TEXT1, txt2
              END IF

           CASE %IDBTN_INFO
              IF CBCTLMSG = %BN_CLICKED THEN 
                 txt = "Text in upper textbox can be converted to CHR$(..) in lower," + $CRLF + _
                       "ready for copying. Lower textbox can convert from CHR$(..)" + $CRLF + _
                       "to text in upper. Use right-click menu in textboxes to copy, etc." + $CRLF + $CRLF + _
                       "That's all, folks..  :-)"

                 CALL MessageBox(CBHNDL, BYVAL STRPTR(txt), _
                                "Information", %MB_OK OR %MB_ICONINFORMATION)
              END IF

           CASE %IDCANCEL : IF CBCTLMSG = %BN_CLICKED THEN DIALOG END CBHNDL
        END SELECT

  END SELECT
END FUNCTION
